blob: 5e874d1cb517005803da0046efaa65c0e181f827 [file] [log] [blame]
Kelly O'Hair213481a2010-12-22 12:25:52 -08001#!/bin/sh
2
3#
Mike Duigou17b823a2014-06-24 15:21:47 -07004# Copyright (c) 2010, 2014, Oracle and/or its affiliates. All rights reserved.
Kelly O'Hair213481a2010-12-22 12:25:52 -08005# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
6#
7# This code is free software; you can redistribute it and/or modify it
8# under the terms of the GNU General Public License version 2 only, as
9# published by the Free Software Foundation. Oracle designates this
10# particular file as subject to the "Classpath" exception as provided
11# by Oracle in the LICENSE file that accompanied this code.
12#
13# This code is distributed in the hope that it will be useful, but WITHOUT
14# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
15# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
16# version 2 for more details (a copy is included in the LICENSE file that
17# accompanied this code).
18#
19# You should have received a copy of the GNU General Public License version
20# 2 along with this work; if not, write to the Free Software Foundation,
21# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
22#
23# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
24# or visit www.oracle.com if you need additional information or have any
25# questions.
26#
27
Mike Duigou02327e82014-07-08 11:21:43 -070028to_stderr() {
29 echo "$@" >&2
30}
31
32error() {
33 to_stderr "ERROR: $1"
34 exit ${2:-126}
35}
36
37warning() {
38 to_stderr "WARNING: $1"
39}
40
41version_field() {
42 # rev is typically omitted for minor and major releases
43 field=`echo ${1}.0 | cut -f ${2} -d .`
44 if expr 1 + $field >/dev/null 2> /dev/null; then
45 echo $field
46 else
47 echo -1
48 fi
49}
50
Mike Duigou17b823a2014-06-24 15:21:47 -070051# Version check
52
53# required
54reqdmajor=1
Mike Duigou02327e82014-07-08 11:21:43 -070055reqdminor=4
Mike Duigou17b823a2014-06-24 15:21:47 -070056reqdrev=0
57
58# requested
59rqstmajor=2
60rqstminor=6
61rqstrev=3
62
Mike Duigou02327e82014-07-08 11:21:43 -070063
Mike Duigou17b823a2014-06-24 15:21:47 -070064# installed
Mike Duigou02327e82014-07-08 11:21:43 -070065hgwhere="`command -v hg`"
Mike Duigou17b823a2014-06-24 15:21:47 -070066if [ "x$hgwhere" = "x" ]; then
Mike Duigou02327e82014-07-08 11:21:43 -070067 error "Could not locate Mercurial command"
Mike Duigou17b823a2014-06-24 15:21:47 -070068fi
69
Mike Duigou02327e82014-07-08 11:21:43 -070070hgversion="`hg --version 2> /dev/null | sed -n -e 's@^Mercurial Distributed SCM (version \([^+]*\).*)\$@\1@p'`"
Mike Duigou17b823a2014-06-24 15:21:47 -070071if [ "x${hgversion}" = "x" ] ; then
Mike Duigou02327e82014-07-08 11:21:43 -070072 error "Could not determine Mercurial version of $hgwhere"
Mike Duigou17b823a2014-06-24 15:21:47 -070073fi
74
Mike Duigou02327e82014-07-08 11:21:43 -070075hgmajor="`version_field $hgversion 1`"
76hgminor="`version_field $hgversion 2`"
77hgrev="`version_field $hgversion 3`"
78
79if [ $hgmajor -eq -1 -o $hgminor -eq -1 -o $hgrev -eq -1 ] ; then
80 error "Could not determine Mercurial version of $hgwhere from \"$hgversion\""
81fi
82
Mike Duigou17b823a2014-06-24 15:21:47 -070083
84# Require
85if [ $hgmajor -lt $reqdmajor -o \( $hgmajor -eq $reqdmajor -a $hgminor -lt $reqdminor \) -o \( $hgmajor -eq $reqdmajor -a $hgminor -eq $reqdminor -a $hgrev -lt $reqdrev \) ] ; then
Mike Duigou02327e82014-07-08 11:21:43 -070086 error "Mercurial version $reqdmajor.$reqdminor.$reqdrev or later is required. $hgwhere is version $hgversion"
Mike Duigou17b823a2014-06-24 15:21:47 -070087fi
88
Mike Duigou02327e82014-07-08 11:21:43 -070089
Mike Duigou17b823a2014-06-24 15:21:47 -070090# Request
91if [ $hgmajor -lt $rqstmajor -o \( $hgmajor -eq $rqstmajor -a $hgminor -lt $rqstminor \) -o \( $hgmajor -eq $rqstmajor -a $hgminor -eq $rqstminor -a $hgrev -lt $rqstrev \) ] ; then
Mike Duigou02327e82014-07-08 11:21:43 -070092 warning "Mercurial version $rqstmajor.$rqstminor.$rqstrev or later is recommended. $hgwhere is version $hgversion"
Mike Duigou17b823a2014-06-24 15:21:47 -070093fi
94
Mike Duigou02327e82014-07-08 11:21:43 -070095
Mike Duigou17b823a2014-06-24 15:21:47 -070096# Get clones of all absent nested repositories (harmless if already exist)
97sh ./common/bin/hgforest.sh clone "$@" || exit $?
Kelly O'Hair213481a2010-12-22 12:25:52 -080098
99# Update all existing repositories to the latest sources
Fredrik Öhrströmccafa0b2012-12-18 09:57:01 +0100100sh ./common/bin/hgforest.sh pull -u